<script lang="ts">
import { reactive } from "vue";
import axios from "axios";
import useNotyf from "@/store/composable/useNotyf";
import Carousel from "@/components/carousel/Carousel.vue";
import KTHeader from "@/layout/header/HeaderV2.vue";
import Roadmap from "@/components/SMK/Roadmap.vue";
import Service from "@/components/SMK/Service.vue";
import Quotes from "@/components/carousel/Quotes.vue";
import { dataService } from "@/assets/data/data";

export default {
  components: {
    KTHeader,
    Carousel,
    Roadmap,
    Service,
    Quotes,
  },
  setup() {
    let api = reactive(process.env.VUE_APP_API_URL);
    const notif = useNotyf();
    interface StateInterface {
      dataBanner: {
        data: Array<string>;
        isLoading: boolean;
      };
      dataRoadmap: {
        data: Array<string>;
      };
      dataQuotes: {
        data: Array<string>;
        isLoading: boolean;
      };
    }

    const state = reactive<StateInterface>({
      dataBanner: {
        data: [],
        isLoading: true,
      },
      dataRoadmap: {
        data: [],
      },
      dataQuotes: {
        data: [],
        isLoading: true,
      },
    });

    const getRoadmap = async () => {
      try {
        const result = await axios.get(`${api}/roadmap`);

        state.dataRoadmap.data = [];
        if (result.status === 200) {
          result.data.forEach((e) => {
            state.dataRoadmap.data.push(e);
          });
        }
      } catch (error: any) {
        notif.error(error);
      }
    };

    const getBanner = async () => {
      try {
        state.dataBanner.isLoading = true;
        const response = await axios.get(`${api}/banner`);
        state.dataBanner.data = [];
        if (response.status === 200) {
          response.data.forEach((e) => {
            state.dataBanner.data.push(e);
          });
          state.dataBanner.isLoading = false;
        }
      } catch (error: any) {
        notif.error(error);
      }
    };

    const getQuotes = async () => {
      try {
        state.dataQuotes.isLoading = true;
        const response = await axios.get(`${api}/quote`);
        state.dataQuotes.data = [];
        if (response.status === 200) {
          response.data.forEach((e) => {
            state.dataQuotes.data.push(e);
          });
          state.dataQuotes.isLoading = false;
        }
      } catch (error: any) {
        notif.error(error);
      }
    };

    getRoadmap();
    getBanner();
    getQuotes();
    return { state, dataService };
  },
};
</script>

<template>
  <div style="background-color: #10203f">
    <div class="container">
      <KTHeader :title="pageTitle" class="mt-3" />
      <div class="spinner" v-if="state.dataBanner.isLoading"></div>
      <Carousel :data="state.dataBanner.data" class="my-10" v-else />
    </div>
  </div>
  <div class="landing-curve landing-dark-color mb-10 mb-lg-20">
    <svg viewBox="15 12 1470 48" fill="none" xmlns="http://www.w3.org/2000/svg">
      <path
        d="M0 11C3.93573 11.3356 7.85984 11.6689 11.7725 12H1488.16C1492.1 11.6689 1496.04 11.3356 1500 11V12H1488.16C913.668 60.3476 586.282 60.6117 11.7725 12H0V11Z"
        fill="rgb(16, 32, 63)"
      ></path>
    </svg>
  </div>
  <div class="roadmap-section container px-5">
    <Roadmap :data="state.dataRoadmap.data" />
  </div>
  <div class="landing-curve landing-dark-color">
    <svg viewBox="15 -1 1470 48" fill="none" xmlns="http://www.w3.org/2000/svg">
      <path
        d="M1 48C4.93573 47.6644 8.85984 47.3311 12.7725 47H1489.16C1493.1 47.3311 1497.04 47.6644 1501 48V47H1489.16C914.668 -1.34764 587.282 -1.61174 12.7725 47H1V48Z"
        fill="rgb(16, 32, 63)"
      ></path>
    </svg>
  </div>

  <div style="background-color: #10203f">
    <div class="service-section container common-layout py-5">
      <Service :data="dataService" />
    </div>
  </div>
  <div class="landing-curve landing-dark-color mb-10 mb-lg-20">
    <svg viewBox="15 12 1470 48" fill="none" xmlns="http://www.w3.org/2000/svg">
      <path
        d="M0 11C3.93573 11.3356 7.85984 11.6689 11.7725 12H1488.16C1492.1 11.6689 1496.04 11.3356 1500 11V12H1488.16C913.668 60.3476 586.282 60.6117 11.7725 12H0V11Z"
        fill="rgb(16, 32, 63)"
      ></path>
    </svg>
  </div>
  <div class="quotes-section container my-10">
    <div class="spinner" v-if="state.dataQuotes.isLoading"></div>
    <Quotes :data="state.dataQuotes.data" v-else />
  </div>
  <div class="mb-0">
    <!--begin::Curve top-->
    <div class="landing-curve landing-dark-color">
      <svg
        viewBox="15 -1 1470 48"
        fill="none"
        xmlns="http://www.w3.org/2000/svg"
      >
        <path
          d="M1 48C4.93573 47.6644 8.85984 47.3311 12.7725 47H1489.16C1493.1 47.3311 1497.04 47.6644 1501 48V47H1489.16C914.668 -1.34764 587.282 -1.61174 12.7725 47H1V48Z"
          fill="currentColor"
        ></path>
      </svg>
    </div>
    <div class="landing-dark-bg pt-20">
      <div class="container">
        <div class="row py-10 py-lg-20">
          <div class="col-lg-6 pe-lg-16 mb-10 mb-lg-0 text-center">
            <img src="@/assets/image/footer.png" alt="" />
          </div>
          <div class="col-lg-6 ps-lg-16">
            <h2 class="text-white mb-20 fs-2hx text-sm-center text-md-start">
              Petualangan dalam hidup adalah seberapa banyak Anda belajar
            </h2>
            <h4
              class="fw-bolder text-gray-400 mb-6 fs-4"
              style="text-align: justify"
            >
              SMK Digital Service merupakan perusahaan yang dibentuk pada tahun
              2021 berada dibawah naungan CV.Edcuare Digital Indonesia dengan
              berkomitmen untuk senantiasa memenuhi dan membantu kebutuhan smk
              baik itu sekolah, guru maupun siswa agar dapat terus bergerak dan
              berkembang mempersiapkan diri menuju industri 4.0.
            </h4>
            <a
              href="https://api.whatsapp.com/send?phone=6285790829138"
              target="_blank"
              rel="noopener noreferrer"
              class="
                btn
                btn-outline
                btn-outline-dashed
                btn-success
                btn-active-light-success
                me-2
                my-sm-5 my-lg-10
              "
            >
              <i class="lab la-whatsapp fs-1"></i>
              Whatsapp
            </a>
            <a
              href="https://www.instagram.com/smkdigitalservice/"
              target="_blank"
              rel="noopener noreferrer"
              class="
                btn
                btn-outline
                btn-outline-dashed
                btn-danger
                btn-active-light-danger
                me-2
                my-sm-5 my-lg-10
              "
            >
              <i class="lab la-instagram fs-1"></i>
              Instagram
            </a>
          </div>
        </div>
      </div>
      <div class="landing-dark-separator"></div>
      <div class="container">
        <div class="d-flex flex-column flex-md-row flex-stack py-7 py-lg-10">
          <div class="d-flex align-items-center order-2 order-md-1">
            <router-link to="/">
              <img
                src="@/assets/image/smkdigitalservicelogo.png"
                class="h-60px pt-1"
              />
              <span class="mx-5 fs-6 fw-bold text-gray-600 pt-1 text-uppercase">
                All rights Reserved © 2022 SMK Digital Service</span
              >
            </router-link>
          </div>
          <ul
            class="
              menu menu-gray-600 menu-hover-primary
              fw-bold
              fs-6 fs-md-5
              order-1
              mb-5 mb-md-0
            "
          >
            <li class="menu-item">
              <a
                href="https://keenthemes.com"
                target="_blank"
                class="menu-link px-2"
                >About</a
              >
            </li>
            <li class="menu-item mx-5">
              <a
                href="https://devs.keenthemes.com"
                target="_blank"
                class="menu-link px-2"
                >Support</a
              >
            </li>
          </ul>
        </div>
      </div>
    </div>
  </div>
</template>